예제 #1
0
 /// <summary>
 /// Initialize GUI with FormatData
 /// </summary>
 ///// <param name="dataBuffer">relevant data from revit</param>
 public FormatForm(ProjectUnitData dataBuffer, Autodesk.Revit.DB.FormatOptions formatoptions)
 {
     InitializeComponent();
     m_dataBuffer                          = dataBuffer;
     m_formatoptions                       = new Autodesk.Revit.DB.FormatOptions(formatoptions.UnitSymbol, formatoptions.DisplayUnits);
     m_formatoptions.UseDefault            = formatoptions.UseDefault;
     m_formatoptions.Accuracy              = formatoptions.Accuracy;
     m_formatoptions.SuppressTrailingZeros = formatoptions.SuppressTrailingZeros;
     m_formatoptions.SuppressLeadingZeros  = formatoptions.SuppressLeadingZeros;
     m_formatoptions.UsePlusPrefix         = formatoptions.UsePlusPrefix;
     m_formatoptions.UseGrouping           = formatoptions.UseGrouping;
     m_formatoptions.SuppressSpaces        = formatoptions.SuppressSpaces;
 }
예제 #2
0
        /// <summary>
        /// Implement this method as an external command for Revit.
        /// </summary>
        /// <param name="commandData">An object that is passed to the external application
        /// which contains data related to the command,
        /// such as the application object and active view.</param>
        /// <param name="message">A message that can be set by the external application
        /// which will be displayed if a failure or cancellation is returned by
        /// the external command.</param>
        /// <param name="elements">A set of elements to which the external application
        /// can add elements that are to be highlighted in case of failure or cancellation.</param>
        /// <returns>Return the status of the external command.
        /// A result of Succeeded means that the API external method functioned as expected.
        /// Cancelled can be used to signify that the user cancelled the external operation
        /// at some point. Failure should be returned if the application is unable to proceed with
        /// the operation.</returns>
        public virtual Result Execute(ExternalCommandData commandData
                                      , ref string message, ElementSet elements)
        {
            try
            {
                Document document             = commandData.Application.ActiveUIDocument.Document;
                Autodesk.Revit.DB.Units units = document.GetUnits();

                //prepare data
                ProjectUnitData dataBuffer = new ProjectUnitData(units);

                // show UI
                using (ProjectUnitForm displayForm = new ProjectUnitForm(dataBuffer))
                {
                    DialogResult result = displayForm.ShowDialog();
                    if (DialogResult.OK == result)
                    {
                        using (Autodesk.Revit.DB.Transaction tran = new Autodesk.Revit.DB.Transaction(document, "SetUnits"))
                        {
                            tran.Start();
                            document.SetUnits(units);
                            tran.Commit();
                        }
                    }
                    else
                    {
                        return(Autodesk.Revit.UI.Result.Cancelled);
                    }
                }

                return(Result.Succeeded);
            }
            catch (Exception ex)
            {
                message = ex.Message;
                return(Result.Failed);
            }
        }
예제 #3
0
 /// <summary>
 /// Initialize GUI with ProjectUnitData
 /// </summary>
 /// <param name="dataBuffer">relevant data from revit</param>
 public ProjectUnitForm(ProjectUnitData dataBuffer)
 {
     InitializeComponent();
     m_dataBuffer = dataBuffer;
 }